/*--------------------------------
 * 
 * Jerome.Gouzy@toulouse.inra.fr
 * Created: 20150630
 * 
 * $Id$
 * 
 - --------------------------------*/      
#include <stdio.h>
#include <stdlib.h>
#include "fasta_utils.h"

//#define JDEBUG 1


void DumpFastaFile(sequence_t **a_sequences,char *outfile,unsigned long long nb_sequences,int minlen)
{
	FILE *f_out  = GetStreamOut(outfile);
	unsigned long long i;
	for(i=0;i<nb_sequences;i++)
	{
		if ( strlen((*a_sequences+i)->seq) >= minlen )
			fprintf(f_out,">%s\n%s\n",(*a_sequences+i)->header,(*a_sequences+i)->seq);
	}
	CloseStream(outfile,f_out);
}

void LoadFastafile(sequence_t **a_sequences,char *infile,unsigned long long *r_nb_sequences,int capitalize)
{
	char line[MAXL+1];
	FILE *f_in  = GetStreamIn(infile);
	unsigned long long nb_seq=0;
	while(fgets(line,MAXL,f_in) != NULL)
	{
		if ( line[0] == '>' )
			nb_seq++;
	}
	CloseStream(infile,f_in);
	fprintf(stderr,"%lld sequences in file %s\n",nb_seq,infile);
	
	*a_sequences=(sequence_t *)malloc(sizeof(sequence_t)*nb_seq);
	unsigned long long i;
	for(i=0;i<nb_seq;i++)
	{
		strcpy((*a_sequences+i)->header,"");
		(*a_sequences+i)->seq=NULL;
	}
	
	int buffer_size=10000000;
//	int buffer_size=75;
	char *buffer=(char *)malloc(sizeof(char)*buffer_size+1);
	buffer[0]='\0';
	
	char *possep=NULL;
	char *currseq=NULL;
	f_in  = GetStreamIn(infile);
	*r_nb_sequences=0;
	int delta = ('a'-'A');
	int lenline,leninbuff=0;
	int seqlen=0;
	while(fgets(line,MAXL,f_in) != NULL)
	{
		lenline=strlen(line);
//	fprintf(stderr,"lenraw=%d, %s\n",lenline,line);
		if ( line[lenline-1] == '\n' )
		{
			line[lenline-1]='\0';
			lenline--;
		}
//		fprintf(stderr,"lenline=%d\n",lenline);
		
		if ( line[0] == '>' )
		{
			if ( currseq != NULL || leninbuff > 0 )
			{
				seqlen=0;
				if ( currseq!=NULL )
					seqlen+=strlen(currseq);
				if ( leninbuff )
					seqlen+=leninbuff;
				(*a_sequences+*r_nb_sequences)->seq=(char *)malloc(sizeof(char)*seqlen+1);
				(*a_sequences+*r_nb_sequences)->seq[0]='\0';
				if ( currseq != NULL )
				{
					strcpy((*a_sequences+*r_nb_sequences)->seq,currseq);
					free(currseq);
					currseq=NULL;
				}
				if ( leninbuff ) 
					strcat((*a_sequences+*r_nb_sequences)->seq,buffer);
				buffer[0]='\0';
				(*r_nb_sequences)++;
			}
			leninbuff=0;
			if ((possep=strchr(line,' '))!=NULL)
				*possep='\0';
			strcpy((*a_sequences+*r_nb_sequences)->header,&line[1]);
		}
		else
		{
			if ( capitalize )
			{
				for(i=0;i<lenline;i++)
					if ( line[i] > 'T' )
						line[i]-=delta;
			}
			if ( (lenline+1+leninbuff) < buffer_size )
			{
				memcpy(&buffer[leninbuff],line,lenline);
				leninbuff+=lenline;
				buffer[leninbuff]='\0';
			}
			else // on vide le buffer
			{
				if ( currseq == NULL )
				{
					currseq=(char*)malloc(leninbuff+lenline+1);
					memcpy(currseq,buffer,leninbuff);
					memcpy(currseq+leninbuff,line,lenline+1); // je copie aussi le \0
				}
				else
				{
					int lencurr=strlen(currseq);
					int newlen=lencurr+leninbuff+lenline+1;
					char *newcurrseq=(char*)malloc(newlen+1);
					memcpy(newcurrseq,currseq,lencurr);
					memcpy(&newcurrseq[lencurr],buffer,leninbuff);
					memcpy(&newcurrseq[lencurr+leninbuff],line,lenline+1); // avec le \0
					free(currseq);
					currseq=newcurrseq;
				}
				buffer[0]='\0';
				leninbuff=0;
			}
		}
	}
	if ( currseq != NULL || leninbuff > 0 )
	{
		seqlen=0;
		if ( currseq!=NULL )
			seqlen+=strlen(currseq);
		if ( leninbuff )
			seqlen+=leninbuff;
		(*a_sequences+*r_nb_sequences)->seq=(char *)malloc(sizeof(char)*seqlen+1);
		(*a_sequences+*r_nb_sequences)->seq[0]='\0';
		if ( currseq != NULL )
		{
			strcpy((*a_sequences+*r_nb_sequences)->seq,currseq);
			free(currseq);
			currseq=NULL;
		}
		if ( leninbuff ) 
			strcat((*a_sequences+*r_nb_sequences)->seq,buffer);
	}
	CloseStream(infile,f_in);
	assert(*r_nb_sequences==(nb_seq-1));
	*r_nb_sequences=nb_seq;
	free(buffer);
}
